VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPPDInformation"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
' Collection of CPPDFeature class objects
'
' Requirements: Class modules 'CPPDFeature.cls'

Private WithEvents m_FeatureClient As ComboBox
Attribute m_FeatureClient.VB_VarHelpID = -1
Private WithEvents m_ChoicesClient As ComboBox
Attribute m_ChoicesClient.VB_VarHelpID = -1

Private m_Col As Collection

Public Event OnFeatureChange(NewFeature As CPPDUIFeature)

Friend Property Set FeatureClient(ByVal vNewClient As ComboBox)

    Dim I&
    Dim vFeatureGroup As CPPDUIFeature
    
    Set m_FeatureClient = vNewClient
    
    If m_Col.Count > 0 Then
        With m_FeatureClient
            .Clear
            For I = 1 To m_Col.Count
                Set vFeatureGroup = m_Col(I)
                .AddItem vFeatureGroup.TranslationName
                .ListIndex = 0
            Next
        End With
    End If

    Set vFeatureGroup = Nothing

End Property

Friend Property Set ChoicesClient(ByVal vNewClient As ComboBox)

    Dim I&
    Set m_ChoicesClient = vNewClient
    
End Property

Public Function Add(vFeatureObj As CPPDUIFeature) As CPPDUIFeature
    'create a new object
    Dim o_New As CPPDUIFeature
    Set o_New = vFeatureObj

    m_Col.Add o_New, o_New.TranslationName

    'return the object created
    Set Add = o_New
    Set o_New = Nothing

End Function

Public Property Get Item(ByVal vntIndexKey As Variant) As CPPDUIFeature
Attribute Item.VB_UserMemId = 0
    Dim I&
    Dim vTmp As CPPDUIFeature
    
    If IsNumeric(vntIndexKey) Then
        On Error Resume Next
        Set Item = m_Col(vntIndexKey)
        If Err.Number = 5 Then
            If m_Col.Count > 0 Then
                For I = 1 To m_Col.Count
                    Set vTmp = m_Col(I)
                    If vTmp.TranslationName = CStr(vntIndexKey) Or vTmp.GroupName = CStr(vntIndexKey) Then
                        Set Item = m_Col(I)
                        Exit Property
                    End If
                Next
            Else
                Set Item = Nothing
            End If
        End If
    Else
        If m_Col.Count > 0 Then
            For I = 1 To m_Col.Count
                Set vTmp = m_Col(I)
                If vTmp.TranslationName = CStr(vntIndexKey) Or vTmp.GroupName = CStr(vntIndexKey) Then
                    Set Item = m_Col(I)
                    Exit Property
                End If
            Next
        Else
            Set Item = Nothing
        End If
    End If
    Set vTmp = Nothing

End Property

Function Exists(index As Variant) As Boolean
    Dim vTmp As CPPDUIFeature
    On Error Resume Next
    If IsNumeric(vntIndexKey) Then
        On Error Resume Next
        Set Item = m_Col(vntIndexKey)
        If Err.Number = 5 Then
            If m_Col.Count > 0 Then
                For I = 1 To m_Col.Count
                    Set vTmp = m_Col(I)
                    If vTmp.TranslationName = CStr(vntIndexKey) Or vTmp.GroupName = CStr(vntIndexKey) Then
                        Set Item = m_Col(I)
                        Err.Clear
                        GoTo BailOut
                    End If
                Next
            Else
                Set Item = Nothing
            End If
        End If
    Else
        If m_Col.Count > 0 Then
            For I = 1 To m_Col.Count
                Set vTmp = m_Col(I)
                If vTmp.TranslationName = CStr(vntIndexKey) Or vTmp.GroupName = CStr(vntIndexKey) Then
                    Set Item = m_Col(I)
                    GoTo BailOut
                End If
            Next
        Else
            Set Item = Nothing
        End If
    End If
BailOut:
    Set vTmp = Nothing
    Exists = (Err = 0)
End Function

Public Property Get Count() As Long
    Count = m_Col.Count
End Property

Public Sub Remove(vntIndexKey As Variant)
    m_Col.Remove vntIndexKey
End Sub

Public Property Get NewEnum() As IUnknown
    Set NewEnum = m_Col.[_NewEnum]
End Property

Private Sub Class_Initialize()
    
    Set m_Col = New Collection

End Sub

Private Sub Class_Terminate()
    
    Set m_Col = Nothing

End Sub

Private Sub m_ChoicesClient_Click()
    
    Dim I&
    Dim vFeatureGroup As CPPDUIFeature
    
    If m_ChoicesClient.ListIndex >= 0 Then
        Set vFeatureGroup = m_Col(m_FeatureClient.ListIndex + 1)
        Set vFeatureGroup.CurrentChoice = vFeatureGroup.Choices(m_ChoicesClient.List(m_ChoicesClient.ListIndex))
    End If
    
    Set vFeatureGroup = Nothing

End Sub

Private Sub m_FeatureClient_Click()
        
   ' If m_ChoicesClient Is Nothing Then Exit Sub
    
    Dim I&
    Dim vPPDChoice As CPPDUIChoice
    Dim vFeatureGroup As CPPDUIFeature
    
    If m_FeatureClient.ListIndex >= 0 Then
        Set vFeatureGroup = m_Col(m_FeatureClient.List(m_FeatureClient.ListIndex))
    
        If vFeatureGroup.Choices.Count > 0 Then
            With m_ChoicesClient
                .Clear
                For I = 1 To vFeatureGroup.Choices.Count
                    Set vPPDChoice = vFeatureGroup.Choices(I)
                    .AddItem vPPDChoice.TranslationName
                Next
                If vFeatureGroup.DefaultChoice Is Nothing Then
                    .ListIndex = 0
                Else
                    If vFeatureGroup.CurrentChoice Is Nothing Then
                        .Text = vFeatureGroup.DefaultChoice.TranslationName
                    Else
                        .Text = vFeatureGroup.CurrentChoice.TranslationName
                    End If
                End If
            End With
        End If
    End If
    
    Set vFeatureGroup = Nothing
    Set vPPDChoice = Nothing

End Sub
