VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPPDUIChoicesObj"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
' Collection of CPPDUIChoice class objects
'
' Requirements: Class modules 'CPPDUIChoice.cls'

Private m_Col As Collection

Public Event OnUIChoiceChange(NewChoice As CPPDUIChoice)

Public Function Add(vChoiceObj As CPPDUIChoice) As CPPDUIChoice
    'create a new object
    Dim o_New As CPPDUIChoice
    Set o_New = vChoiceObj
    
    On Error Resume Next
    m_Col.Add o_New, o_New.ChoiceName
    If Err.Number = 457 Then
        Debug.Print o_New.ChoiceName & " already exist in this feature group"
        Err.Clear
    End If

    'return the object created
    Set Add = o_New
    Set o_New = Nothing

End Function

Public Property Get Item(ByVal vntIndexKey As Variant) As CPPDUIChoice
Attribute Item.VB_UserMemId = 0
    Dim I&
    Dim vTmp As CPPDUIChoice
    
    If IsNumeric(vntIndexKey) Then
        On Error Resume Next
        Set Item = m_Col(vntIndexKey)
        If Err.Number = 5 Then
            If m_Col.Count > 0 Then
                For I = 1 To m_Col.Count
                    Set vTmp = m_Col(I)
                    If vTmp.TranslationName = CStr(vntIndexKey) Or vTmp.ChoiceName = CStr(vntIndexKey) Then
                        Set Item = m_Col(I)
                        Exit Property
                    End If
                Next
            Else
                Set Item = Nothing
            End If
        End If
    Else
        If m_Col.Count > 0 Then
            For I = 1 To m_Col.Count
                Set vTmp = m_Col(I)
                If vTmp.TranslationName = CStr(vntIndexKey) Or vTmp.ChoiceName = CStr(vntIndexKey) Then
                    Set Item = m_Col(I)
                    Exit Property
                End If
            Next
        Else
            Set Item = Nothing
        End If
    End If
    Set vTmp = Nothing
End Property

Public Property Get Count() As Long
    Count = m_Col.Count
End Property

Public Sub Remove(vntIndexKey As Variant)
    m_Col.Remove vntIndexKey
End Sub

Public Property Get NewEnum() As IUnknown
    Set NewEnum = m_Col.[_NewEnum]
End Property

Private Sub Class_Initialize()
    
    Set m_Col = New Collection

End Sub

Private Sub Class_Terminate()
    
    Set m_Col = Nothing

End Sub



